using System.Collections.ObjectModel;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// ׸ ÷
    /// </summary>
    private ObservableCollection<Item> ItemCollection = new ObservableCollection<Item>();

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ItemCollection = GetItemCollection();

        this.selectAllButton.Click   += selectAllButton_Click;
        this.createOrderButton.Click += createOrderButton_Click;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region Select all ư Ŭ óϱ - selectAllButton_Click(sender, e)

    /// <summary>
    /// Select all ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void selectAllButton_Click(object sender, RoutedEventArgs e)
    {
        if(this.treeView.SelectionMode == TreeViewSelectionMode.Multiple)
        {
            this.treeView.SelectAll();
        }
    }

    #endregion
    #region Create order ư Ŭ óϱ - createOrderButton_Click(sender, e)

    /// <summary>
    /// Create order ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void createOrderButton_Click(object sender, RoutedEventArgs e)
    {
        this.flavorListTextBlock.Text  = string.Empty;
        this.toppingListTextBlock.Text = string.Empty;

        foreach(TreeViewNode treeViewNode in this.treeView.SelectedNodes)
        {
            if(treeViewNode.Parent == null)
            {
                continue;
            }

            if(treeViewNode.Parent.Content?.ToString() == "Flavors")
            {
                this.flavorListTextBlock.Text += treeViewNode.Content + "; ";
            }
            else if(treeViewNode.HasChildren == false)
            {
                this.toppingListTextBlock.Text += treeViewNode.Content + "; ";
            }
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region ׸ ÷ ϱ - GetItemCollection()

    /// <summary>
    /// ׸ ÷ ϱ
    /// </summary>
    /// <returns>׸ ÷</returns>
    private ObservableCollection<Item> GetItemCollection()
    {
        ObservableCollection<Item> collection = new ObservableCollection<Item>();

        Item item1 = new Item()
        {
            Name                = "Flavors",
            ChildItemCollection =
            {
                new Item() { Name = "Vanilla"    },
                new Item() { Name = "Strawberry" },
                new Item() { Name = "Chocolate"  }
            }
        };

        Item item2 = new Item()
        {
            Name                = "Toppings",
            ChildItemCollection =
            {
                new Item()
                {
                    Name                = "Candy",
                    ChildItemCollection =
                    {
                        new Item() { Name = "Chocolate" },
                        new Item() { Name = "Mint"      },
                        new Item() { Name = "Sprinkles" }
                    }
                },
                new Item()
                {
                    Name                = "Fruits",
                    ChildItemCollection =
                    {
                        new Item() { Name = "Mango" },
                        new Item() { Name = "Peach" },
                        new Item() { Name = "Kiwi"  }
                    }
                },
                new Item()
                {
                    Name                = "Berries",
                    ChildItemCollection =
                    {
                        new Item() { Name = "Strawberry" },
                        new Item() { Name = "Blueberry"  },
                        new Item() { Name = "Blackberry" }
                    }
                }
            }
        };

        collection.Add(item1);
        collection.Add(item2);

        return collection;
    }

    #endregion
}